<?php
/*
*
*  @author smilepay 
*  <service@smse.comt.tw>
*/

if (!defined('_PS_VERSION_'))
	exit;

class Smilepay_credit extends PaymentModule
{
	private $_html = '';
	private $_postErrors = array();

	public $Dcvc;
	public $Mid;
	public $Apiurl;
	

	public function __construct()
	{
		$this->name = 'smilepay_credit';
		$this->tab = 'payments_gateways';
		$this->version = '1.0';
		$this->author = 'SmilePay';
    
		$this->Apiurl = 'http://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
    //$this->Apiurl = 'https://ssl.smse.com.tw/ezpos_test/mtmk_utf.asp';
    
		$this->currencies = true;
		$this->currencies_mode = 'checkbox';

		$config = Configuration::getMultiple(array('SMILEPAY_credit_DCVC', 'SMILEPAY_credit_MID'));
		if (isset($config['SMILEPAY_credit_DCVC']))
			$this->Dcvc = $config['SMILEPAY_credit_DCVC'];
		if (isset($config['SMILEPAY_credit_MID']))
			$this->Mid = $config['SMILEPAY_credit_MID'];

		parent::__construct();

		$this->displayName = $this->l('Smilepay credit');
		$this->description = "Smilepay Services credit Payment";
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
    
		if ((!isset($this->Dcvc) || !isset($this->Mid) || empty($this->Dcvc) || empty($this->Mid)))
			$this->warning = $this->l('The  Shop code and Check code must be configured in order to use this module correctly.');
		if (!count(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency set for this module');	
     
	}

	public function install()
	{
		if (!parent::install() || !$this->registerHook('payment') || !$this->registerHook('paymentReturn'))
			return false;
		return true;
	}

	public function uninstall()
	{
    if (!Configuration::deleteByName('SMILEPAY_credit_DCVC') || !Configuration::deleteByName('SMILEPAY_credit_MID') || !parent::uninstall())
			return false;
		return true;
	}

	private function _postValidation()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			if (!Tools::getValue('Dcvc'))
				$this->_postErrors[] = $this->l('Shop code field is required.');
			elseif (!Tools::getValue('Mid'))
				$this->_postErrors[] = $this->l('Check code is required.');
		}
	}

	private function _postProcess()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			Configuration::updateValue('SMILEPAY_credit_DCVC', Tools::getValue('Dcvc'));
			Configuration::updateValue('SMILEPAY_credit_MID', Tools::getValue('Mid'));
		}
		$this->_html .= '<div class="conf confirm"> '.$this->l('Settings updated').'</div>';
	}

	private function _displaySmilepay()
	{
		$this->_html .= '<img src="../modules/smilepay_credit/smilepay_credit.jpg" style="float:left; margin-right:15px;"><b>'.$this->l('This module allows you to accept payments by Smilepay credit.').'</b><br /><br />';
	}

	private function _displayForm()
	{
		$this->_html .=
		'<form action="'.Tools::htmlentitiesUTF8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Contact details').'</legend>
				<table border="0" width="500" cellpadding="0" cellspacing="0" id="form">
					<tr><td colspan="2">'.$this->l('Please specify the Shop code and Check code to smilepay credit.').'.<br /><br /></td></tr>
					<tr><td width="130" style="height: 35px;">'.$this->l('Shop code').'</td><td><input type="text" name="Dcvc" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Dcvc', $this->Dcvc)).'" style="width: 300px;" /></td></tr>
					<tr>
						<td width="130" style="vertical-align: top;">'.$this->l('Check code').'</td>
						<td><input type="text" name="Mid" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Mid', $this->Mid)).'" style="width: 300px;" />            
            </td>
					</tr>
					<tr><td colspan="2" align="center"><br /><input class="button" name="btnSubmit" value="'.$this->l('Update settings').'" type="submit" /></td></tr>
				</table>
			</fieldset>
		</form>';
	}

	public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';

		if (Tools::isSubmit('btnSubmit'))
		{
			$this->_postValidation();
			if (!count($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors as $err)
					$this->_html .= '<div class="alert error">'.$err.'</div>';
		}
		else
			$this->_html .= '<br />';

		$this->_displaySmilepay();
		$this->_displayForm();

		return $this->_html;
	}


	public function hookPayment($params)
	{
		if (!$this->active)
			return;
		if (!$this->checkCurrency($params['cart']))
			return;

		$this->smarty->assign(array(
			'this_path' => $this->_path,
			'this_path_ssl' => Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/'.$this->name.'/'
		));
		return $this->display(__FILE__, 'payment.tpl');
	}

	public function hookPaymentReturn($params)
	{     
 
		if (!$this->active)
			return;

          
		$state = $params['objOrder']->getCurrentState();
		if ($state == Configuration::get('PS_OS_CHEQUE') || $state == Configuration::get('PS_OS_OUTOFSTOCK'))
		{ 
          
         // post value
     
    $classif       = trim($_POST['Classif']);
    $data_id      = trim($_POST['Data_id']);
    $od_sob      = trim($_POST['Od_sob']);      
    $amount             = trim($_POST['Amount']);
    $smseid             = trim($_REQUEST['Smseid']);  
    $mid_smilepay       = trim($_POST['Mid_smilepay']);
    $respid             = trim($_POST['Response_id']);
    $LastPan       = $_POST['LastPan'];  
    
      
      
    //取得訂單資訊
    //$order_history = new Order($data_id);
    //$order_db_amount  = round($order_history->getOrdersTotalPaid());
    
      $order_db_amount  = round($params['total_to_pay']) ;
                  
         //checksum Mid and Mid_smilepay from SmielPay      
      if(isset($this->Mid)){          
                 
        if(!$this->midfun($this->Mid,$order_db_amount,$smseid,$mid_smilepay)){  
          die("Possible fraud");
        }                                             
      }                    
             
      if ($amount == $order_db_amount && ($classif == 'A'  &&  $respid=='1'))
      {
                 
                      
        		/* For 1.4.3 and less compatibility 
		$updateConfig = array('PS_OS_CHEQUE' => 1, 'PS_OS_PAYMENT' => 2, 'PS_OS_PREPARATION' => 3, 'PS_OS_SHIPPING' => 4,
		'PS_OS_DELIVERED' => 5, 'PS_OS_CANCELED' => 6, 'PS_OS_REFUND' => 7, 'PS_OS_ERROR' => 8, 'PS_OS_OUTOFSTOCK' => 9,
		'PS_OS_BANKWIRE' => 10, 'PS_OS_PAYPAL' => 11, 'PS_OS_WS_PAYMENT' => 12);
                            */
            $newOrderStatusId=2;
            $history = new OrderHistory();
            $history->id_order = (int)($data_id);
            $history->changeIdOrderState($newOrderStatusId,$data_id);            
            $history->addWithemail();                                
            
            
    			$this->smarty->assign(array(    				
    				'status' => 'ok',    				     
            'total' => $amount,                         
    				'id_order' => $data_id,
            'this_path' => $this->_path                                                                                                     
    			));        
          
    			if (isset($params['objOrder']->reference) && !empty($params['objOrder']->reference))
    				$this->smarty->assign('reference', $params['objOrder']->reference); 
      
      }  else{
      
            $newOrderStatusId=8;
            $history = new OrderHistory();
            $history->id_order = (int)($data_id);
            $history->changeIdOrderState($newOrderStatusId,$data_id);            
            $history->addWithemail();  
            
          $Errdesc   = iconv("big5","UTF-8", $_REQUEST['Errdesc']);                        
    			$this->smarty->assign(array(    				
    				'status' => 'failed',  				     
    				'errdesc' =>$Errdesc,
            'this_path' => $this->_path                                                                                                     
    			));
      }
		}
		else
 			$this->smarty->assign(array(    				
  				'status' => 'failed',
          'this_path' => $this->_path                                                                                                     
  			));
		return $this->display(__FILE__, 'payment_return.tpl');
	}
     
  // compute Mid      
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }
}

	public function checkCurrency($cart)
	{
		$currency_order = new Currency((int)($cart->id_currency));
		$currencies_module = $this->getCurrency((int)$cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
				if ($currency_order->id == $currency_module['id_currency'])
					return true;
		return false;
	}
}
