<?php
/*
*
*  @author smilepay 
*  <service@smse.comt.w>
*/


if (!defined('_PS_VERSION_'))
	exit;

class Smilepay_csv extends PaymentModule
{
	private $_html = '';
	private $_postErrors = array();

	public $Dcvc;
	public $Mid;
	public $Apiurl;
	public $cus_csv;
	

	public function __construct()
	{
		$this->name = 'smilepay_csv';
		$this->tab = 'payments_gateways';
		$this->version = '1.0';
		$this->author = 'SmilePay';
    
		$this->Apiurl = 'http://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
		

		$this->currencies = true;
		$this->currencies_mode = 'checkbox';
		
		$config = Configuration::getMultiple(array('SMILEPAY_csv_DCVC', 'SMILEPAY_csv_MID','SMILEPAY_csv_CUS'));
		if (isset($config['SMILEPAY_csv_DCVC']))
			$this->Dcvc = $config['SMILEPAY_csv_DCVC'];
		if (isset($config['SMILEPAY_csv_MID']))
			$this->Mid = $config['SMILEPAY_csv_MID'];
		if (isset($config['SMILEPAY_csv_CUS']))
			$this->cus_csv = $config['SMILEPAY_csv_CUS'];	

		parent::__construct();

		$this->displayName = $this->l('Smilepay csv');
		$this->description = "Smilepay Services csv Payment";
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
    
		if ((!isset($this->Dcvc) || !isset($this->Mid) || empty($this->Dcvc) || empty($this->Mid)))
			$this->warning = $this->l('The  Shop code and Check code must be configured in order to use this module correctly.');
		if (!count(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency set for this module');	
     
	}

	public function install()
	{
		if (!parent::install() || !$this->registerHook('payment') || !$this->registerHook('paymentReturn'))
			return false;
		return true;
	}

	public function uninstall()
	{
    if (!Configuration::deleteByName('SMILEPAY_csv_DCVC') || !Configuration::deleteByName('SMILEPAY_csv_MID') || !Configuration::deleteByName('SMILEPAY_csv_CUS') || !parent::uninstall())
			return false;
		return true;
	}

	private function _postValidation()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			if (!Tools::getValue('Dcvc'))
				$this->_postErrors[] = $this->l('Shop code field is required.');
			elseif (!Tools::getValue('Mid'))
				$this->_postErrors[] = $this->l('Check code is required.');
		}
	}

	private function _postProcess()
	{
		if (Tools::isSubmit('btnSubmit'))
		{
			Configuration::updateValue('SMILEPAY_csv_DCVC', Tools::getValue('Dcvc'));
			Configuration::updateValue('SMILEPAY_csv_MID', Tools::getValue('Mid'));
			Configuration::updateValue('SMILEPAY_csv_CUS', Tools::getValue('cus_csv'));
		}
		$this->_html .= '<div class="conf confirm"> '.$this->l('Settings updated').'</div>';
	}

	private function _displaySmilepay()
	{
		$this->_html .= '<img src="../modules/smilepay_csv/smilepay_csv.jpg" style="float:left; margin-right:15px;"><b>'.$this->l('This module allows you to accept payments by Smilepay csv.').'</b><br /><br />';
	}

	private function _displayForm()
	{
	(Configuration::get('SMILEPAY_csv_CUS')  == '1') ? $cus_csv_checked ='checked' : $cus_csv_checked='';
		$this->_html .=
		'<form action="'.Tools::htmlentitiesUTF8($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Contact details').'</legend>
				<table border="0" width="500" cellpadding="0" cellspacing="0" id="form">
					<tr><td colspan="2">'.$this->l('Please specify the Shop code and Check code to smilepay csv.').'.<br /><br /></td></tr>
					<tr><td width="130" style="height: 35px;">'.$this->l('Shop code').'</td><td><input type="text" name="Dcvc" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Dcvc', $this->Dcvc)).'" style="width: 300px;" /></td></tr>
					<tr>
						<td width="130" style="vertical-align: top;">'.$this->l('Check code').'</td>
						<td><input type="text" name="Mid" value="'.Tools::htmlentitiesUTF8(Tools::getValue('Mid', $this->Mid)).'" style="width: 300px;" />            
            </td>
					</tr>
					<tr>
          <td width="130" style="vertical-align: top;">'.$this->l('payment model').'</td>
          <td>
          <input type="checkbox" name="cus_csv" value="1" '.$cus_csv_checked .' /> '.$this->l('custom bill').' <br/>                    
          </td>
          </tr>  
					<tr><td colspan="2" align="center"><br /><input class="button" name="btnSubmit" value="'.$this->l('Update settings').'" type="submit" /></td></tr>
				</table>
			</fieldset>
		</form>';
	}

	public function getContent()
	{
		$this->_html = '<h2>'.$this->displayName.'</h2>';

		if (Tools::isSubmit('btnSubmit'))
		{
			$this->_postValidation();
			if (!count($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors as $err)
					$this->_html .= '<div class="alert error">'.$err.'</div>';
		}
		else
			$this->_html .= '<br />';

		$this->_displaySmilepay();
		$this->_displayForm();

		return $this->_html;
	}


	public function hookPayment($params)
	{
		if (!$this->active)
			return;
		if (!$this->checkCurrency($params['cart']))
			return;

		$this->smarty->assign(array(
			'this_path' => $this->_path,
			'this_path_ssl' => Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/'.$this->name.'/'
		));
		return $this->display(__FILE__, 'payment.tpl');
	}

	public function hookPaymentReturn($params)
	{     
 
		if (!$this->active)
			return;


		$state = $params['objOrder']->getCurrentState();
		if ($state == Configuration::get('PS_OS_CHEQUE') || $state == Configuration::get('PS_OS_OUTOFSTOCK'))
		{ 
    
     	$id_order = trim($_GET['id_order']);
    	$id_cart = trim($_GET['id_cart']);   
    	$id_module = trim($_GET['id_module']);
    	$key = trim($_GET['key']);	
        
        //自訂帳單判斷
        $pay_zg='3';
        $account_roturl='';
        $cus = 'no';
        if($this->cus_csv == '1'){
            $pay_zg='9';
            $account_roturl=Tools::getHttpHost(true).__PS_BASE_URI__.'index.php?fc=module&module=smilepay_csv&controller=paybill&id_lang='.$_GET['id_lang'].'&id_cart='.(int)$id_cart.'&id_module='.(int)$id_module.'&id_order='.$id_order.'&key='.$key;
            $cus = 'yes';    
        }		
    	$user_address = new Address(intval($params['cart']->id_address_invoice));
    
			$this->smarty->assign(array(
				'total_to_pay' => Tools::displayPrice($params['total_to_pay'], $params['currencyObj'], false),
				'status' => 'ok',
				'Apiurl' => $this->Apiurl,
        'dcvc' =>  	$this->Dcvc,    
        'pay_zg' =>  	$pay_zg,
        'account_roturl' =>  $account_roturl,
        'cus' =>  	$cus, 
        'od_sob' => $params['objOrder']->reference,
        'total' => round($params['total_to_pay']),
        'cus_name' => $params['cookie']->customer_lastname.$params['cookie']->customer_firstname,
				'cus_tel' =>  $user_address->phone,
				'cus_mobile' => $user_address->phone_mobile,
        
        'cus_email' => $params['cookie']->email,
        'roturl_url' => "http://".$_SERVER["HTTP_HOST"].$this->_path."sprespon.php",               
				'id_order' => $params['objOrder']->id,
        'this_path' => $this->_path                                                                                                     
			));
			if (isset($params['objOrder']->reference) && !empty($params['objOrder']->reference))
				$this->smarty->assign('reference', $params['objOrder']->reference);
		}
		else
			$this->smarty->assign('status', 'failed');
		return $this->display(__FILE__, 'payment_return.tpl');
	}

	public function checkCurrency($cart)
	{
		$currency_order = new Currency((int)($cart->id_currency));
		$currencies_module = $this->getCurrency((int)$cart->id_currency);

		if (is_array($currencies_module))
			foreach ($currencies_module as $currency_module)
				if ($currency_order->id == $currency_module['id_currency'])
					return true;
		return false;
	}
}
